package com.iot.modbus_rtcp.netty;

import cn.hutool.core.map.BiMap;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class IPGatewayRelation {

    // key ：ip value ：网关编码(网关标识)
    private static Map<String, String> mIPGatewayMap = new ConcurrentHashMap<>();
    // key ：网关标识 value ：ip端口
    private static BiMap<String, String> addressMap = new BiMap<>(new ConcurrentHashMap<>());

    public static String get(String ipAddressKey) {
        return mIPGatewayMap.get(ipAddressKey);
    }

    public static void put(String ipAddressKey, String gatewayCodeMapping) {
        mIPGatewayMap.put(ipAddressKey, gatewayCodeMapping);
    }

    public static void putIPAddressMap(String gatewayIdentifier, String ipAddressKey) {
        addressMap.put(gatewayIdentifier, ipAddressKey);
    }

    public static String getIPAddress(String gatewayIdentifier) {
        return addressMap.get(gatewayIdentifier);
    }

    public static String getGatewayIdentifier(String ipAddressKey) {
        return addressMap.getInverse().get(ipAddressKey);
    }

    public static String getGatewayIdentifier(String ip, int port) {
        return getGatewayIdentifier(ChannelGroup.getKey(ip, port));
    }

}
