package com.iot.modbus_rtcp.vo;

public enum ResponseCode {
    SUCCESS(200, "操作成功"),
    FAILURE(400, "操作失败"),
    /**
     * 参数错误代码
     */
    PARAM_IS_INVALID(1001, "参数无效"),
    PARAM_IS_BLANK(1002, "参数为空"),
    PARAM_TYPE_BIND_ERROR(1003, "参数类型错误"),
    PARAM_NOT_COMPLETE(1004, "参数缺失"),
    PARAM_ERROR(1004, "参数错误"),
    /**
     * 用户错误代码
     */
    USER_NOT_LOGIN_IN(2001, "手机号未登录"),
    USER_LOGIN_ERROR(2002, "账号或密码输入有误"),
    USER_ACCOUNT_FORBIDDEN(2003, "手机号被冻结"),
    USER_NOT_EXIST(2004, "账号或手机号未注册"),
    USER_HAS_EXISTED(2005, "账号或手机号已注册"),
    USER_NOT_BIND(2006, "用户需要绑定手机号"),
    USER_MORE(2007, "系统存在多个正常状态的账号或手机号，请联系管理员"),

    /**
     * 权限验证错误
     */
    USER_AUTHORIZATION_ERROR(3001, "用户权限错误"),
    USER_NO_LOGIN(3002, "尚未登录，请登录"),
    USER_PREV_NO_ATTENDED(3003, "上轮您未投票，不可以继续投票了"),
    USER_NO_ATTENDED(3004, "本轮您未投票"),
    /**
     * 其他系统错误
     */
    SYSTEM_ERROR(4001, "系统错误"),
    VERIFY_CODE_ERROR(4002, "验证码错误！");

    int code;
    String message;

    ResponseCode(int code, String message) {
        this.message = message;
        this.code = code;
    }

    public String message() {
        return this.message;
    }

    public int code() {
        return this.code;
    }
}
